diff --git a/xen/arch/arm/vgic-v3.c b/xen/arch/arm/vgic-v3.c
index 9818a6b..704b774 100644
--- a/xen/arch/arm/vgic-v3.c
+++ b/xen/arch/arm/vgic-v3.c
@@ -179,13 +179,13 @@ static int __vgic_v3_rdistr_rd_mmio_read(struct vcpu *v, mmio_info_t *info,
         /* Reserved0 */
         goto read_as_zero;
     default:
-        printk("vGICv3: vGICR: read r%d offset %#08x\n not found",
-               dabt.reg, gicr_reg);
+        gdprintk(XENLOG_ERR, "vGICR: read r%d offset %#08x\n not found",
+                 dabt.reg, gicr_reg);
         return 0;
     }
 bad_width:
-    printk("vGICv3: vGICR: bad read width %d r%d offset %#08x\n",
-           dabt.size, dabt.reg, gicr_reg);
+    gdprintk(XENLOG_ERR, "vGICR: bad read width %d r%d offset %#08x\n",
+             dabt.size, dabt.reg, gicr_reg);
     domain_crash_synchronous();
     return 0;
 
@@ -249,7 +249,8 @@ static int __vgic_v3_rdistr_rd_mmio_write(struct vcpu *v, mmio_info_t *info,
         /* RO */
         goto write_ignore;
     default:
-        printk("vGICR: write r%d offset %#08x\n not found", dabt.reg, gicr_reg);
+        gdprintk(XENLOG_ERR, "vGICR: write r%d offset %#08x\n not found",
+                 dabt.reg, gicr_reg);
         return 0;
     }
 write_ignore:
@@ -341,15 +342,14 @@ static int __vgic_v3_distr_common_mmio_read(struct vcpu *v, mmio_info_t *info,
         vgic_unlock_rank(v, rank, flags);
         return 1;
     default:
-        printk("vGICv3: vGICD/vGICR: unhandled read r%d offset %#08x\n",
-               dabt.reg, reg);
+        gdprintk(XENLOG_ERR, "vGIC{D,R}: unhandled read r%d offset %#08x\n",
+                 dabt.reg, reg);
         return 0;
     }
 
 bad_width:
-    dprintk(XENLOG_ERR,
-            "vGICv3: vGICD/vGICR: bad read width %d r%d offset %#08x\n",
-            dabt.size, dabt.reg, reg);
+    gdprintk(XENLOG_ERR, "vGIC{D,R}: bad read width %d r%d offset %#08x\n",
+             dabt.size, dabt.reg, reg);
     domain_crash_synchronous();
     return 0;
 
@@ -456,15 +456,16 @@ static int __vgic_v3_distr_common_mmio_write(struct vcpu *v, mmio_info_t *info,
         vgic_unlock_rank(v, rank, flags);
         return 1;
     default:
-        printk("vGICv3: vGICD/vGICR: unhandled write r%d "
-               "=%"PRIregister" offset %#08x\n", dabt.reg, *r, reg);
+        gdprintk(XENLOG_ERR,
+                 "vGIC{D,R}: unhandled write r%d=%"PRIregister" offset %#08x\n",
+                 dabt.reg, *r, reg);
         return 0;
     }
 
 bad_width:
-    dprintk(XENLOG_ERR,
-            "vGICv3: vGICD/vGICR: bad write width %d r%d=%"PRIregister" "
-            "offset %#08x\n", dabt.size, dabt.reg, *r, reg);
+    gdprintk(XENLOG_ERR,
+             "vGIC{D,R}: bad write width %d r%d=%"PRIregister" offset %#08x\n",
+             dabt.size, dabt.reg, *r, reg);
     domain_crash_synchronous();
     return 0;
 
@@ -521,13 +522,13 @@ static int vgic_v3_rdistr_sgi_mmio_read(struct vcpu *v, mmio_info_t *info,
         if ( dabt.size != DABT_WORD ) goto bad_width;
         return 1;
     default:
-        printk("vGICv3: vGICR: read r%d offset %#08x\n not found",
-               dabt.reg, gicr_reg);
+        gdprintk(XENLOG_ERR, "vGICR: SGI: read r%d offset %#08x\n not found",
+                dabt.reg, gicr_reg);
         return 0;
     }
 bad_width:
-    printk("vGICv3: vGICR: bad read width %d r%d offset %#08x\n",
-           dabt.size, dabt.reg, gicr_reg);
+    gdprintk(XENLOG_ERR, "vGICR: SGI: bad read width %d r%d offset %#08x\n",
+            dabt.size, dabt.reg, gicr_reg);
     domain_crash_synchronous();
     return 0;
 
@@ -587,14 +588,15 @@ static int vgic_v3_rdistr_sgi_mmio_write(struct vcpu *v, mmio_info_t *info,
         /* We do not implement security extensions for guests, write ignore */
         goto write_ignore;
     default:
-        printk("vGICv3: vGICR SGI: write r%d offset %#08x\n not found",
-               dabt.reg, gicr_reg);
+        gdprintk(XENLOG_ERR, "vGICR: SGI: write r%d offset %#08x\n not found",
+                 dabt.reg, gicr_reg);
         return 0;
     }
 
 bad_width:
-    printk("vGICR SGI: bad write width %d r%d=%"PRIregister" offset %#08x\n",
-           dabt.size, dabt.reg, *r, gicr_reg);
+    gdprintk(XENLOG_ERR,
+             "vGICR: SGI: bad write width %d r%d=%"PRIregister" offset %#08x\n",
+             dabt.size, dabt.reg, *r, gicr_reg);
     domain_crash_synchronous();
     return 0;
 
@@ -622,7 +624,7 @@ static int vgic_v3_rdistr_mmio_read(struct vcpu *v, mmio_info_t *info)
         return vgic_v3_rdistr_sgi_mmio_read(v, info, (offset - SZ_64K));
     else
         gdprintk(XENLOG_WARNING,
-                 "vGICv3: vGICR: unknown gpa read address %"PRIpaddr"\n",
+                 "vGICR: unknown gpa read address %"PRIpaddr"\n",
                  info->gpa);
 
     return 0;
@@ -646,7 +648,7 @@ static int vgic_v3_rdistr_mmio_write(struct vcpu *v, mmio_info_t *info)
         return vgic_v3_rdistr_sgi_mmio_write(v, info, (offset - SZ_64K));
     else
         gdprintk(XENLOG_WARNING,
-                 "vGICV3: vGICR: unknown gpa write address %"PRIpaddr"\n",
+                 "vGICR: unknown gpa write address %"PRIpaddr"\n",
                  info->gpa);
 
     return 0;
@@ -796,14 +798,14 @@ static int vgic_v3_distr_mmio_read(struct vcpu *v, mmio_info_t *info)
         /* These are reserved register addresses */
         goto read_as_zero;
     default:
-        printk("vGICv3: vGICD: unhandled read r%d offset %#08x\n",
-               dabt.reg, gicd_reg);
+        gdprintk(XENLOG_ERR, "vGICD: unhandled read r%d offset %#08x\n",
+                 dabt.reg, gicd_reg);
         return 0;
     }
 
 bad_width:
-    dprintk(XENLOG_ERR, "vGICv3: vGICD: bad read width %d r%d offset %#08x\n",
-            dabt.size, dabt.reg, gicd_reg);
+    gdprintk(XENLOG_ERR, "vGICD: bad read width %d r%d offset %#08x\n",
+             dabt.size, dabt.reg, gicd_reg);
     domain_crash_synchronous();
     return 0;
 
@@ -865,8 +867,9 @@ static int vgic_v3_distr_mmio_write(struct vcpu *v, mmio_info_t *info)
     case 0x020 ... 0x03c:
     case 0xc000 ... 0xffcc:
         /* Implementation defined -- write ignored */
-        printk("vGICv3: vGICD: write unknown 0x020 - 0x03c r%d offset %#08x\n",
-               dabt.reg, gicd_reg);
+        gdprintk(XENLOG_WARNING,
+                 "vGICD: write unknown 0x020 - 0x03c r%d offset %#08x\n",
+                 dabt.reg, gicd_reg);
         goto write_ignore;
     case GICD_IGROUPR ... GICD_IGROUPRN:
     case GICD_ISENABLER ... GICD_ISENABLERN:
@@ -910,8 +913,9 @@ static int vgic_v3_distr_mmio_write(struct vcpu *v, mmio_info_t *info)
             new_target = new_irouter & MPIDR_AFF0_MASK;
             if ( new_target >= v->domain->max_vcpus )
             {
-                printk("vGICv3: vGICD: wrong irouter at offset %#08x\n val 0x%lx vcpu %x",
-                       gicd_reg, new_target, v->domain->max_vcpus);
+                gdprintk(XENLOG_ERR,
+                         "vGICD: wrong irouter at offset %#08x\n val 0x%lx vcpu %x",
+                         gicd_reg, new_target, v->domain->max_vcpus);
                 vgic_unlock_rank(v, rank, flags);
                 return 0;
             }
@@ -951,19 +955,20 @@ static int vgic_v3_distr_mmio_write(struct vcpu *v, mmio_info_t *info)
     case 0xf30 ... 0x5fcc:
     case 0x8000 ... 0xbfcc:
         /* Reserved register addresses */
-        printk("vGICv3: vGICD: write unknown 0x00c 0xfcc  r%d offset %#08x\n",
-                dabt.reg, gicd_reg);
+        gdprintk(XENLOG_WARNING, "write unknown 0x00c 0xfcc  r%d offset %#08x\n",
+                 dabt.reg, gicd_reg);
         goto write_ignore;
     default:
-        printk("vGICv3: vGICD: unhandled write r%d=%"PRIregister" "
-               "offset %#08x\n", dabt.reg, *r, gicd_reg);
+        gdprintk(XENLOG_ERR,
+                 "vGICD: unhandled write r%d=%"PRIregister" offset %#08x\n",
+                 dabt.reg, *r, gicd_reg);
         return 0;
     }
 
 bad_width:
-    dprintk(XENLOG_ERR,
-            "VGICv3: vGICD: bad write width %d r%d=%"PRIregister" "
-            "offset %#08x\n", dabt.size, dabt.reg, *r, gicd_reg);
+    gdprintk(XENLOG_ERR,
+             "vGICD: bad write width %d r%d=%"PRIregister" offset %#08x\n",
+             dabt.size, dabt.reg, *r, gicd_reg);
     domain_crash_synchronous();
     return 0;
 